PROGRAM Compile_CRACK;
USES Dos, GUtils;

CONST
  PatternSize = 25;
  MaxCrack    = 20;

TYPE
  PArr2000   = ^TArr2000;
  TArr2000   = ARRAY[1..2000] OF Byte;

  TByteData  = RECORD
      Search : STRING[PatternSize];
     Replace : STRING[PatternSize];
  END;
  TCrackData = RECORD
        Logo : ARRAY[1..2000,1..2] OF Byte;
      YCoord : Byte;
  CrackTotal : Byte;
    FileName : STRING[12];
        Data : ARRAY[1..MaxCrack] OF TByteData;
  END;


CONST
  ID: ARRAY[1..4] OF Char = 'DATA';


VAR
  ID_Bytes        : ARRAY[1..4] OF Char;
  OVL             : STRING;
  Offset          : LongInt;
  CrackData       : TCrackData;
  ScriptFileName  : STRING;
  CompileFileName : STRING;


  PROCEDURE WriteInf(L,S:STRING; LA,SA:Byte);
  BEGIN
    Attribute(WhereX,WhereY,LA,Length(L));
    Attribute(WhereX+Length(L),WhereY,SA,Length(S));
    Writeln(L,S);
  END;


  PROCEDURE Error(Msg:STRING);
  BEGIN
    WriteInf('ERROR: ',Msg,$04,$0C);
    Halt(1)
  END;

  PROCEDURE ScriptError(Msg:STRING);
  BEGIN
    WriteInf('SCRIPT FILE ERROR: ',Msg,$04,$0C);
    Halt(1)
  END;


{---------------------------------------------------------------------------}
{---------------------------------------------------------------------------}
{---------------------------------------------------------------------------}
PROCEDURE InitFindReplace(VAR NEW_Find,NEW_Replace:STRING);
VAR I,R: Byte; S1,S2: STRING[2];
BEGIN
  NEW_Find    := StripAll(NEW_Find   ,' ');
  NEW_Replace := StripAll(NEW_Replace,' ');
  IF Odd(Length(NEW_Find))    THEN NEW_Find[0]    := Chr(Ord(NEW_Find[0])-1);
  IF Odd(Length(NEW_Replace)) THEN NEW_Replace[0] := Chr(Ord(NEW_Replace[0])-1);
  R := 0;
  FOR I := 1 TO Length(NEW_Find) DO
  BEGIN
    S1 := Copy(NEW_Find   ,I,2);
    S2 := Copy(NEW_Replace,I,2);
    Inc(I); Inc(R);
    NEW_Find   [R] := Chr(HexToDec(S1));
    NEW_Replace[R] := Chr(HexToDec(S2));
  END;
  NEW_Find[0]    := Chr(Ord(NEW_Find[0])    DIV 2);
  NEW_Replace[0] := Chr(Ord(NEW_Replace[0]) DIV 2);
END;


{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}
PROCEDURE GenerateCrackData;
VAR ScriptFile   : Text;
    Crk          : FILE;
    LogoFile     : FILE;
    Line,Fnd,Rep : STRING;
    Chrs,Attr    : PArr2000;
    I            : Integer;

  PROCEDURE GetLine(VAR S:STRING);
  BEGIN
    REPEAT
      ReadLn(ScriptFile,S);
      S := StripLeft(S,' ');
      IF S[1] = ';' THEN FillChar(S,SizeOf(S),0);
      IF S = '' THEN Continue ELSE Break;
    UNTIL Eof(ScriptFile);
  END;

BEGIN
  FillChar(CrackData, SizeOf(CrackData), 0);
  WriteInf(' Compiling: ',ScriptFileName+' -> '+CompileFileName,$0A,$02);
  Writeln;
  Assign(ScriptFile,ScriptFileName);
  {$I-}
    Reset(ScriptFile);
  {$I+}
  IF IOResult <> 0 THEN Error('Can''t open '+ScriptFileName);
  GetLine(Line); WriteInf('TITLE: ',Line,$09,$0B);
  GetLine(Line); WriteInf('LOGO:  ',Line,$09,$0B);

           Assign(LogoFile,Line);
           {$I-} Reset(LogoFile,1); {$I+}
           IF IOResult <> 0 THEN ScriptError('Can''t open '+Line);
           BlockRead(LogoFile,CrackData.Logo,SizeOf(CrackData.Logo));
           Close(LogoFile);
           New(Chrs); New(Attr);
           FOR I := 1 TO 2000 DO
           BEGIN
             Chrs^[I] := CrackData.Logo[I,1];
             Attr^[I] := CrackData.Logo[I,2];
           END;
           Move(Chrs^,CrackData.Logo[1,1]   ,2000);
           Move(Attr^,CrackData.Logo[1001,1],2000);
           Dispose(Chrs); Dispose(Attr);

  GetLine(Line); CrackData.YCoord := StrToInt(Line);
  WriteInf('YPOS:  ',IntToStr(CrackData.YCoord),$09,$0B);
  IF (CrackData.YCoord < 2) OR (CrackData.YCoord > 25)
    THEN ScriptError('Cursor YPOS must be <24 and >1');

  GetLine(Line); CrackData.FileName := Line;
  WriteInf('FILE:  ',CrackData.FileName,$09,$0B);

  REPEAT
    Inc(CrackData.CrackTotal);

    GetLine(Fnd);
    ReadLn(ScriptFile,Rep);

    InitFindReplace(Fnd,Rep);
    CrackData.Data[CrackData.CrackTotal].Search  := Fnd;
    CrackData.Data[CrackData.CrackTotal].Replace := Rep;
    IF CrackData.CrackTotal = MaxCrack THEN Break;
  UNTIL Eof(ScriptFile);
  Close(ScriptFile);
  WriteInf('SRCH#: ',IntToStr(CrackData.CrackTotal),$09,$0B);
END;



PROCEDURE SaveCrackData;
VAR Crk:FILE;
BEGIN
  CopyFile(OVL,CompileFileName);
  Assign(Crk,CompileFileName);
  {$I-}
    Reset(Crk,1);
  {$I-}
  IF IOresult <> 0 THEN Error('Can''t open '+CompileFileName);
  Seek(Crk,Offset);
  BlockRead(Crk,ID_Bytes,SizeOf(ID_Bytes));
  IF ID_Bytes <> ID THEN
  BEGIN
    Close(Crk);
    Error('Can''t locate DATA marker. EC3_OVL.OVL version mismatch!');
  END;
  BlockWrite(Crk,CrackData,SizeOf(CrackData));
  Close(Crk);
END;





{***************************************************************************}
{****************************** MAIN PROGRAM *******************************}
{***************************************************************************}
BEGIN
  Offset := $BC2;
  ClrScr(7);
  ClearAttr(1,1,80,1,$5);
  ClearAttr(1,2,80,2,$D);
  Writeln('           EASY CRACK V4.0       ');
  Writeln('    Copyright (C) 1997 by The GodFather');
  Writeln;

  IF ParamCount < 1
    THEN BEGIN
           WriteInf('USAGE: ','EC4 script_file_name [crack_file_name]',$0E,$0F);
           Halt(0);
         END;

  OVL := 'EC4_OVL.OVL';
  IF NOT FindFile(OVL)
    THEN Error('Can''t find EC4_OVL.OVL');
  OVL := FExpand(OVL);
  WriteInf(' OVL found: ',OVL,$0A,$02);

  ScriptFileName  := AdjCase(Upper, ParamStr(1));
  IF ParamCount >= 2
    THEN CompileFileName := AdjCase(Upper, BaseNameOnly(ParamStr(2))+'.EXE')
    ELSE CompileFileName := AdjCase(Upper, BaseNameOnly(ScriptFileName)+'.EXE');

  GenerateCrackData;
  SaveCrackData;

  Writeln;
  WriteInf(CompileFileName,' is created.',$0F,$07);
END.